﻿module Game

open System
open System.Timers

//====================================================
// Подробное описание работы классов и методов исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
//====================================================


type Game() =
    let timer =
        new Timer(Interval = 150, Enabled = true)

    let snake = Snake.Snake()

    // Выбор направления движения.
    let mutable direction = 0

    // Функция получения текущих координат головы змейки.
    let gameStop (pos: Snake.pos) =
        if pos.row = 0 && pos.col = 0 then
            direction <- 1

        if pos.row = Console.WindowWidth - 1 && pos.col = 0 then
            direction <- 3

        if pos.row = Console.WindowWidth - 1
           && pos.col = Console.WindowHeight - 1 then
            direction <- 2

        if pos.row = 0 && pos.col = Console.WindowHeight - 1 then
            direction <- 4

    let timerClick (source: Object) (e: System.Timers.ElapsedEventArgs) : unit =
        snake.Move direction
        gameStop (snake.Pos)

        // Для надёжного скрытия курсора.
        // При изменении размеров окна курсор вновь появляется.
        Console.CursorVisible <- false

    do timer.Elapsed.AddHandler(timerClick)

    // Методы взаимодействия с пользователем.
    member x.Right() = direction <- 1
    member x.Left() = direction <- 2
    member x.Down() = direction <- 3
    member x.Up() = direction <- 4
